Attribute VB_Name = "Common"
Option Explicit

' Note - Use error handlers in procedures that call these functions

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
          (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
          (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
           ByVal lpParams As String, ByVal lpDir As String, ByVal nShowCmd As Long) As Long

Public Declare Function OSWinHelp Lib "user32" Alias "WinHelpA" _
          (ByVal hWnd As Long, ByVal lpHelpFile As String, _
           ByVal wCommand As Long, ByVal dwData As Long) As Long

Public Enum HelpTypeFlags
    HelpContents = 3
    SearchForHelpOn = 261
    HowToUseHelp = 4
End Enum

Private Declare Function GetAttribs Lib "kernel32" Alias "GetFileAttributesA" _
    (ByVal lpSpec As String) As Long

Private Declare Function GetLongPathName Lib "kernel32" Alias "GetLongPathNameA" _
    (ByVal lpszShortPath As String, ByVal lpszLongPath As String, _
     ByVal cchBuffer As Long) As Long

Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" _
    (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, _
     ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, _
     Arguments As Long) As Long

Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000&
Private Const sEMPTY_STR = "Empty string passed."
Private Const iscMODE_MARGIN As Long = 8

Public Const ZERO As Long = 0
Public Const ONE As Long = 1
Public Const TWO As Long = 2
Public Const THREE As Long = 3
Public Const FOUR As Long = 4
Public Const FIVE As Long = 5

' Maximum allowed path length including path, filename,
' and command line arguments for NT (Intel) and Win95
Public Const MAX_PATH As Long = 260
Public Const DIR_SEP As String = "\"

' PI is: 3.1415926535897932384626433832795028841971694
Public Const PI As Double = 3.14159265358979 'PI = 4 * Atn(1)

Public Function RandomColor() As Long 'Returns a random color
    Dim Red As Long ' Jay
    Dim Green As Long
    Dim Blue As Long
    
    Call Randomize(Timer)
    Red = Random(1, 255)
    Green = Random(1, 255)
    Blue = Random(1, 255)
    RandomColor = RGB(Red, Green, Blue)
End Function

' Bounced off Paul Catons InIDE
Public Function InTheIDE() As Boolean
    Debug.Assert True Xor DebugOnly(InTheIDE)
End Function

Private Function DebugOnly(fInIDE As Boolean) As Boolean
    fInIDE = True
End Function

Public Function FileExists(sFileSpec As String) As Boolean
    If LenB(sFileSpec) = ZERO Then Err.Raise FIVE, , sEMPTY_STR
    Dim Attribs As Long: Attribs = GetAttribs(sFileSpec)
    If (Attribs <> -ONE) Then
        FileExists = ((Attribs And vbDirectory) <> vbDirectory)
    End If
End Function

Public Function DirExists(sPath As String) As Boolean
    If LenB(sPath) = ZERO Then Err.Raise FIVE, , sEMPTY_STR
    Dim Attribs As Long: Attribs = GetAttribs(sPath)
    If (Attribs <> -ONE) Then
        DirExists = ((Attribs And vbDirectory) = vbDirectory)
    End If
End Function

Public Function LongPathName(sPathName As String) As String
    If LenB(sPathName) = 0 Then Exit Function
    LongPathName = sPathName ' Default to the short name
    On Error GoTo GetFailed
    Dim sPath As String, lResult As Long
    sPath = String$(MAX_PATH, vbNullChar)
    lResult = GetLongPathName(sPathName, sPath, MAX_PATH)
    If (lResult) Then LongPathName = TrimZ(sPath)
GetFailed:
End Function

Public Function TrimZ(sNullTerminated As String) As String
    If (LenB(sNullTerminated) = ZERO) Then Err.Raise FIVE, , sEMPTY_STR
    Dim Idx As Integer: Idx = InStr(sNullTerminated, vbNullChar)
    If (Idx <> ZERO) Then
        TrimZ = Left$(sNullTerminated, Idx - ONE)
    Else
        TrimZ = Trim$(sNullTerminated)
    End If
End Function

Public Function InStrR(sSrc As String, sTerm As String, _
                        Optional ByVal lLeftBound As Long = ONE, _
                        Optional ByVal lRightBound As Long, _
                        Optional CaseSensative As Boolean) As Long
    If (LenB(sSrc) = ZERO) Or (LenB(sTerm) = ZERO) Then Err.Raise FIVE
    Dim lPos As Long, lTerm As Long
    If lRightBound = ZERO Then lRightBound = Len(sSrc)
    lTerm = Len(sTerm)
    lRightBound = (lRightBound - lTerm) + ONE
    If CaseSensative Then
        lLeftBound = InStr(sSrc, sTerm)
        If lLeftBound = ZERO Then Exit Function
        For lPos = lRightBound To lLeftBound Step -ONE
            If (Mid$(sSrc, lPos, lTerm) = sTerm) Then
                InStrR = lPos
                Exit Function
            End If
        Next lPos
    Else
        Dim sText As String, sFind As String
        sText = LCase$(sSrc): sFind = LCase$(sTerm)
        lLeftBound = InStr(sText, sFind)
        If lLeftBound = ZERO Then Exit Function
        For lPos = lRightBound To lLeftBound Step -ONE
            If (Mid$(sText, lPos, lTerm) = sFind) Then
                InStrR = lPos
                Exit Function
            End If
        Next lPos
    End If
End Function

Public Function Padding(Value, ByVal lLength As Long, _
                       Optional sPadChar As String = "0", _
                       Optional fSuffixPadding As Boolean) As String
    If (lLength > Len(Value)) Then
        If fSuffixPadding Then
            Padding = CStr(Value) & String$(lLength - Len(Value), sPadChar)
        Else
            Padding = String$(lLength - Len(Value), sPadChar) & CStr(Value)
        End If
    Else
        Padding = Left$(CStr(Value), lLength)
    End If
End Function

Public Function Today() As Date
    Today = Date
End Function

Public Function Tomorrow() As Date
    Tomorrow = DateAdd("d", 1, Date)
End Function

Public Function Yesterday() As Date
    Yesterday = DateAdd("d", -1, Date)
End Function

Public Function SplitString(sStr As String) As String()
    If (LenB(sStr) = 0) Then Err.Raise FIVE, , sEMPTY_STR
    Dim iLength As Integer, idxArr As Integer
    Dim idx1 As Integer, idx2 As Integer
    Dim s As String, aStrs() As String
    s = Trim(sStr)
    idx1 = ONE
    If (InStr(s, vbNullChar)) Then ' Seperated by Nulls
        Do While idx1 < Len(s)
            idx2 = InStr(idx1, s, vbNullChar)
            If (idx2 = ZERO) Then idx2 = Len(s) + ONE
            iLength = idx2 - idx1
            ReDim Preserve aStrs(ZERO To idxArr) As String
            aStrs(idxArr) = TrimQuotes(Mid$(s, idx1, iLength))
            idxArr = idxArr + ONE
            idx1 = idx2 + ONE
        Loop
    Else ' Seperated by Spaces
        Dim iSpc As Integer, iQuot As Integer
        iSpc = InStr(s, Chr$(32)) ' Space char
        iQuot = InStr(s, Chr$(34)) ' Quote char
        If (iSpc = ZERO) And (iQuot = ZERO) Then
            ReDim aStrs(ZERO To ZERO) As String
            aStrs(ZERO) = s
        ElseIf (iSpc = ZERO) Then
            ReDim aStrs(ZERO To ZERO) As String
            aStrs(ZERO) = TrimQuotes(s)
        ElseIf (iQuot = ZERO) Then ' And (iSpc <> ZERO)
            Do While idx1 < Len(s)
                idx2 = InStr(idx1, s, Chr$(32))
                If (idx2 = ZERO) Then idx2 = Len(s) + ONE
                iLength = idx2 - idx1 ' truncates space char
                ReDim Preserve aStrs(ZERO To idxArr) As String
                aStrs(idxArr) = Mid$(s, idx1, iLength)
                idxArr = idxArr + ONE
                idx1 = idx2 + ONE
            Loop
        Else ' (iSpc <> ZERO) And (iQuot <> ZERO)
            idx1 = InStr(idx1, s, Chr$(34))
            Do While idx1 < Len(s)
                idx2 = InStr(idx1 + ONE, s, Chr$(34))
                If (idx2 = ZERO) Then Err.Raise FIVE, , "Invalid number of quotation characters."
                iLength = idx2 - idx1
                ReDim Preserve aStrs(ZERO To idxArr) As String
                aStrs(idxArr) = Mid$(s, idx1 + ONE, iLength - ONE)
                If (idx1 = ONE) Then
                    s = Mid$(s, idx2 + ONE)
                Else
                    s = Mid$(s, ONE, idx1 - ONE) & Mid$(s, idx2 + ONE)
                End If
                idxArr = idxArr + ONE
                idx1 = InStr(idx1, s, Chr$(34))
                If (idx1 = ZERO) Then idx1 = Len(s)
            Loop
            s = Trim(s)
            Do While LenB(s) <> 0
                idx2 = InStr(ONE, s, Chr$(32))
                If (idx2 = ZERO) Then idx2 = Len(s) + ONE
                ReDim Preserve aStrs(ZERO To idxArr) As String
                aStrs(idxArr) = Mid$(s, ONE, idx2 - ONE)
                If (idx2 > Len(s)) Then Exit Do
                s = Mid$(s, idx2 + ONE)
                s = Trim(s)
                idxArr = idxArr + ONE
            Loop
        End If
    End If
    SplitString = aStrs
End Function

Public Function AddBackslash(sSpec As String) As String
    If (LenB(sSpec) = 0) Then Err.Raise FIVE, , sEMPTY_STR
    ' Add trailing backslash if missing
    If Right$(sSpec, ONE) <> DIR_SEP Then
        AddBackslash = sSpec & DIR_SEP
    Else
        AddBackslash = sSpec
    End If
End Function

Public Function RemoveBackslash(sSpec As String) As String
    If (LenB(sSpec) = 0) Then Err.Raise FIVE, , sEMPTY_STR
    ' Remove trailing backslash
    If Right$(sSpec, ONE) = DIR_SEP Then
        RemoveBackslash = Left$(sSpec, Len(sSpec) - ONE)
    Else
        RemoveBackslash = sSpec
    End If
End Function

Public Function AddPathSeperator(sSpec As String, Optional sSep As String) As String
    If (LenB(sSpec) = 0) Then Err.Raise FIVE, , sEMPTY_STR
    If (LenB(sSep) = 0) Then
        sSep = IIf(InStr(sSpec, "/"), "/", DIR_SEP)
    Else
        If InStr(sSpec, IIf(sSep = DIR_SEP, "/", DIR_SEP)) Then Err.Raise FIVE
    End If
    ' Add trailing seperator if missing
    If Right$(sSpec, ONE) <> sSep Then
        AddPathSeperator = sSpec & sSep
    Else
        AddPathSeperator = sSpec
    End If
End Function

Public Function RemovePathSeperator(sSpec As String) As String
    If (LenB(sSpec) = 0) Then Err.Raise FIVE, , sEMPTY_STR
    Dim sSep As String: sSep = IIf(InStr(sSpec, "/"), "/", DIR_SEP)
    ' Remove trailing seperator
    If Right$(sSpec, ONE) = sSep Then
        RemovePathSeperator = Left$(sSpec, Len(sSpec) - ONE)
    Else
        RemovePathSeperator = sSpec
    End If
End Function

Public Function TrimQuotes(sStr As String) As String
    If (LenB(sStr) = 0) Then Err.Raise FIVE, , sEMPTY_STR
    Dim s As String: s = Trim$(sStr)
    ' Remove double quotes if present
    If (Left$(s, 1) = Chr$(34)) Then
        TrimQuotes = Mid$(s, 2, Len(s) - 2)
    Else
        TrimQuotes = Trim$(s)
    End If
End Function

Public Function SysRetCodeToMsg(ByVal APIReturnCode As Long) As String
    SysRetCodeToMsg = "Unknown System Error"

    If (APIReturnCode <> ZERO) Then
        Dim rc As Long, lFlag As Long
        Dim MsgBuf As String, BufLen As Long

        BufLen = 1024
        MsgBuf = String$(BufLen, vbNullChar)
        lFlag = FORMAT_MESSAGE_FROM_SYSTEM

        rc = FormatMessage(lFlag, ZERO&, APIReturnCode, ZERO&, MsgBuf, BufLen, ZERO&)
        If (rc <> ZERO) Then SysRetCodeToMsg = TrimZ(MsgBuf)
    Else
        SysRetCodeToMsg = "Returned success or failed to return"
    End If

End Function

Public Function Random(ByVal min As Long, ByVal max As Long, Optional ByVal seed As Long) As Long
    Randomize (5 * seed) * Timer
    Random = CLng((max - min) * Rnd + min)
End Function

Public Function RandomInt(Optional ByVal seed As Long) As Integer
    Randomize (5 * seed) * Timer
    RandomInt = CInt((65535 * Rnd) - 32768)
End Function

Public Function RandomLong(Optional ByVal seed As Long) As Long
    Randomize (5 * seed) * Timer
    RandomLong = CLng((4294967295# * Rnd) - 2147483648#)
End Function

Public Function RandomSingle(Optional ByVal seed As Long) As Single
    Randomize (5 * seed) * Timer
    RandomSingle = CSng((6.85646E+37 * Rnd) - 3.42823E+37)
End Function

Public Function RandomDouble(Optional ByVal seed As Long) As Double
    RandomDouble = CDbl(RandomSingle(seed) * RandomSingle(seed))
End Function

Public Sub HourGlass(Optional fOn As Boolean = True)
    Static OrigPointer As Long ' 0 = vbDefault
    If fOn Then
        If Screen.MousePointer <> vbHourglass Then
            ' Save pointer and set hourglass
            OrigPointer = Screen.MousePointer
            Screen.MousePointer = vbHourglass
        End If
    Else
        ' Restore pointer
        Screen.MousePointer = OrigPointer
    End If
End Sub

Public Function GetFuncPointer(ByVal AddressOf_Func As Long) As Long
    GetFuncPointer = AddressOf_Func
End Function

Public Function Help(ByVal Me_hWnd As Long, ByVal HelpType As HelpTypeFlags) As Long
    Dim rc As Long
    ' If there is no helpfile for this project display a message to the user
    ' Set the HelpFile for your application in the Project Properties dialog
    If (HelpType = 4) Then
        rc = OSWinHelp(Me_hWnd, "Winhlp32.hlp", 4, 0)
    Else
        If Len(App.HelpFile) = 0 Then
            MsgBox "Unable to display Help Contents.", vbInformation, App.Title
        Else
            rc = OSWinHelp(Me_hWnd, App.HelpFile, HelpType, 0)
        End If
    End If
End Function

